"use strict";
exports.__esModule = true;
var _1 = require("./");
function printFunctionTypeAnnotationParams(node, ctx) {
    return node.params
        .map(function (p) {
        if (!p.name) {
            var type = _1["default"](p.typeAnnotation, ctx).trim();
            if (/^[A-Za-z0-9]+$/.test(type)) {
                return type + ": " + type;
            }
            throw ctx.getError('Expected parameter to have a name', p);
        }
        return "" + p.name.name + (p.optional ? '?' : '') + ": " + _1["default"](p.typeAnnotation, ctx);
    })
        .concat(node.rest
        ? ["..." + node.rest.name + ": " + _1["default"](node.rest.typeAnnotation, ctx)]
        : [])
        .join(', ');
}
exports.printFunctionTypeAnnotationParams = printFunctionTypeAnnotationParams;
function printFunctionTypeAnnotation(node, ctx) {
    var typeParameters = node.typeParameters
        ? _1["default"](node.typeParameters, ctx)
        : '';
    var params = printFunctionTypeAnnotationParams(node, ctx);
    if (!node.returnType) {
        throw ctx.getError('This function is exported, so it needs a return type.', node);
    }
    var returnType = _1["default"](node.returnType, ctx);
    return typeParameters + "(" + params + ") => " + returnType;
}
exports["default"] = printFunctionTypeAnnotation;
