"use strict";
exports.__esModule = true;
var bt = require("babel-types");
var _1 = require("./");
function printObjectProperty(node, ctx) {
    if (node.shorthand) {
        return _1["default"](node.key, ctx);
    }
    if (node.computed) {
        return "[" + _1["default"](node.key, ctx) + "]: " + _1["default"](node.value, ctx);
    }
    if (bt.isStringLiteral(node.key)) {
        return JSON.stringify(node.key.value) + ": " + _1["default"](node.value, ctx) + ",";
    }
    if (bt.isIdentifier(node.key)) {
        return node.key.name + ": " + _1["default"](node.value, ctx) + ",";
    }
    throw ctx.getError('Expected the key of this property to be an Identifier or a StringLiteral.', node);
}
exports["default"] = printObjectProperty;
