"use strict";
exports.__esModule = true;
var bt = require("babel-types");
var _1 = require("./");
function printObjectTypeCallProperty(node, ctx) {
    var value = node.value;
    if (!bt.isFunctionTypeAnnotation(value)) {
        throw ctx.getError('Expected function type annotation', value);
    }
    var typeParameters = value.typeParameters
        ? _1["default"](value.typeParameters, ctx)
        : '';
    var params = value.params
        .map(function (p) {
        if (!p.name) {
            var type = _1["default"](p.typeAnnotation, ctx).trim();
            if (/^[A-Za-z0-9]+$/.test(type)) {
                return type + ": " + type;
            }
            throw ctx.getError('Expected parameter to have a name', p);
        }
        return "" + p.name.name + (p.optional ? '?' : '') + ": " + _1["default"](p.typeAnnotation, ctx);
    })
        .concat(value.rest
        ? ["..." + value.rest.name + ": " + _1["default"](value.rest.typeAnnotation, ctx)]
        : [])
        .join(', ');
    if (!value.returnType) {
        throw ctx.getError('This function is exported, so it needs a return type.', node);
    }
    var returnType = _1["default"](value.returnType, ctx);
    return typeParameters + "(" + params + "): " + returnType;
}
exports["default"] = printObjectTypeCallProperty;
