"use strict";
exports.__esModule = true;
var bt = require("babel-types");
var _1 = require("./");
var FunctionTypeAnnotation_1 = require("./FunctionTypeAnnotation");
function printObjectTypeProperty(node, ctx) {
    var staticMarker = node.static ? 'static ' : '';
    var optionalMarker = node.optional ? '?' : '';
    if (bt.isStringLiteral(node.key)) {
        return "" + staticMarker + JSON.stringify(node.key.value) + optionalMarker + ": " + _1["default"](node.value, ctx) + ";";
    }
    if (bt.isIdentifier(node.key)) {
        if (node.key.name === 'constructor' &&
            !staticMarker &&
            !optionalMarker &&
            bt.isFunctionTypeAnnotation(node.value) &&
            (!node.value.typeParameters ||
                node.value.typeParameters.params.length === 0)) {
            return node.key.name + "(" + FunctionTypeAnnotation_1.printFunctionTypeAnnotationParams(node.value, ctx) + ")";
        }
        return "" + staticMarker + node.key.name + optionalMarker + ": " + _1["default"](node.value, ctx) + ";";
    }
    throw ctx.getError('Expected the key of this type property to be an Identifier or a StringLiteral.', node);
}
exports["default"] = printObjectTypeProperty;
