"use strict";
exports.__esModule = true;
var fs_1 = require("fs");
var AnyTypeAnnotation_1 = require("./AnyTypeAnnotation");
var ArrayTypeAnnotation_1 = require("./ArrayTypeAnnotation");
var ArrowFunctionExpression_1 = require("./ArrowFunctionExpression");
var BinaryExpression_1 = require("./BinaryExpression");
var BooleanLiteral_1 = require("./BooleanLiteral");
var BooleanTypeAnnotation_1 = require("./BooleanTypeAnnotation");
var CallExpression_1 = require("./CallExpression");
var ConditionalExpression_1 = require("./ConditionalExpression");
var DeclareClass_1 = require("./DeclareClass");
var DeclareFunction_1 = require("./DeclareFunction");
var ExistentialTypeParam_1 = require("./ExistentialTypeParam");
var ExportSpecifier_1 = require("./ExportSpecifier");
var FunctionDeclaration_1 = require("./FunctionDeclaration");
var FunctionExpression_1 = require("./FunctionExpression");
var FunctionTypeAnnotation_1 = require("./FunctionTypeAnnotation");
var GenericTypeAnnotation_1 = require("./GenericTypeAnnotation");
var Identifier_1 = require("./Identifier");
var ImportDefaultSpecifier_1 = require("./ImportDefaultSpecifier");
var ImportSpecifier_1 = require("./ImportSpecifier");
var InterfaceDeclaration_1 = require("./InterfaceDeclaration");
var IntersectionTypeAnnotation_1 = require("./IntersectionTypeAnnotation");
var LogicalExpression_1 = require("./LogicalExpression");
var MemberExpression_1 = require("./MemberExpression");
var MixedTypeAnnotation_1 = require("./MixedTypeAnnotation");
var NullLiteralTypeAnnotation_1 = require("./NullLiteralTypeAnnotation");
var NullableTypeAnnotation_1 = require("./NullableTypeAnnotation");
var NumberTypeAnnotation_1 = require("./NumberTypeAnnotation");
var NumericLiteral_1 = require("./NumericLiteral");
var NumericLiteralTypeAnnotation_1 = require("./NumericLiteralTypeAnnotation");
var ObjectExpression_1 = require("./ObjectExpression");
var ObjectProperty_1 = require("./ObjectProperty");
var ObjectTypeAnnotation_1 = require("./ObjectTypeAnnotation");
var ObjectTypeCallProperty_1 = require("./ObjectTypeCallProperty");
var ObjectTypeIndexer_1 = require("./ObjectTypeIndexer");
var ObjectTypeProperty_1 = require("./ObjectTypeProperty");
var SingleImportDeclaration_1 = require("./SingleImportDeclaration");
var SingleVariableDeclaration_1 = require("./SingleVariableDeclaration");
var StringLiteral_1 = require("./StringLiteral");
var StringLiteralTypeAnnotation_1 = require("./StringLiteralTypeAnnotation");
var StringTypeAnnotation_1 = require("./StringTypeAnnotation");
var TemplateLiteral_1 = require("./TemplateLiteral");
var TupleTypeAnnotation_1 = require("./TupleTypeAnnotation");
var TypeAlias_1 = require("./TypeAlias");
var TypeAnnotation_1 = require("./TypeAnnotation");
var TypeCastExpression_1 = require("./TypeCastExpression");
var TypeParameterInstantiation_1 = require("./TypeParameterInstantiation");
var TypeofTypeAnnotation_1 = require("./TypeofTypeAnnotation");
var UnionTypeAnnotation_1 = require("./UnionTypeAnnotation");
var VoidTypeAnnotation_1 = require("./VoidTypeAnnotation");
function print(node, ctx) {
    switch (node.type) {
        case 'AnyTypeAnnotation':
            return AnyTypeAnnotation_1["default"](node, ctx);
        case 'ArrayTypeAnnotation':
            return ArrayTypeAnnotation_1["default"](node, ctx);
        case 'ArrowFunctionExpression':
            return ArrowFunctionExpression_1["default"](node, ctx);
        case 'BinaryExpression':
            return BinaryExpression_1["default"](node, ctx);
        case 'BooleanLiteral':
            return BooleanLiteral_1["default"](node, ctx);
        case 'BooleanTypeAnnotation':
            return BooleanTypeAnnotation_1["default"](node, ctx);
        case 'CallExpression':
            return CallExpression_1["default"](node, ctx);
        case 'ConditionalExpression':
            return ConditionalExpression_1["default"](node, ctx);
        case 'DeclareClass':
            return DeclareClass_1["default"](node, ctx);
        case 'DeclareFunction':
            return DeclareFunction_1["default"](node, ctx);
        case 'ExistentialTypeParam':
            return ExistentialTypeParam_1["default"](node, ctx);
        case 'ExportSpecifier':
            return ExportSpecifier_1["default"](node, ctx);
        case 'FunctionDeclaration':
            return FunctionDeclaration_1["default"](node, ctx);
        case 'FunctionExpression':
            return FunctionExpression_1["default"](node, ctx);
        case 'FunctionTypeAnnotation':
            return FunctionTypeAnnotation_1["default"](node, ctx);
        case 'GenericTypeAnnotation':
            return GenericTypeAnnotation_1["default"](node, ctx);
        case 'Identifier':
            return Identifier_1["default"](node, ctx);
        case 'ImportDefaultSpecifier':
            return ImportDefaultSpecifier_1["default"](node, ctx);
        case 'ImportSpecifier':
            return ImportSpecifier_1["default"](node, ctx);
        case 'InterfaceDeclaration':
            return InterfaceDeclaration_1["default"](node, ctx);
        case 'IntersectionTypeAnnotation':
            return IntersectionTypeAnnotation_1["default"](node, ctx);
        case 'LogicalExpression':
            return LogicalExpression_1["default"](node, ctx);
        case 'MemberExpression':
            return MemberExpression_1["default"](node, ctx);
        case 'MixedTypeAnnotation':
            return MixedTypeAnnotation_1["default"](node, ctx);
        case 'NullLiteralTypeAnnotation':
            return NullLiteralTypeAnnotation_1["default"](node, ctx);
        case 'NullableTypeAnnotation':
            return NullableTypeAnnotation_1["default"](node, ctx);
        case 'NumberTypeAnnotation':
            return NumberTypeAnnotation_1["default"](node, ctx);
        case 'NumericLiteral':
            return NumericLiteral_1["default"](node, ctx);
        case 'NumericLiteralTypeAnnotation':
            return NumericLiteralTypeAnnotation_1["default"](node, ctx);
        case 'ObjectExpression':
            return ObjectExpression_1["default"](node, ctx);
        case 'ObjectProperty':
            return ObjectProperty_1["default"](node, ctx);
        case 'ObjectTypeAnnotation':
            return ObjectTypeAnnotation_1["default"](node, ctx);
        case 'ObjectTypeCallProperty':
            return ObjectTypeCallProperty_1["default"](node, ctx);
        case 'ObjectTypeIndexer':
            return ObjectTypeIndexer_1["default"](node, ctx);
        case 'ObjectTypeProperty':
            return ObjectTypeProperty_1["default"](node, ctx);
        case 'SingleImportDeclaration':
            return SingleImportDeclaration_1["default"](node, ctx);
        case 'SingleVariableDeclaration':
            return SingleVariableDeclaration_1["default"](node, ctx);
        case 'StringLiteral':
            return StringLiteral_1["default"](node, ctx);
        case 'StringLiteralTypeAnnotation':
            return StringLiteralTypeAnnotation_1["default"](node, ctx);
        case 'StringTypeAnnotation':
            return StringTypeAnnotation_1["default"](node, ctx);
        case 'TemplateLiteral':
            return TemplateLiteral_1["default"](node, ctx);
        case 'TupleTypeAnnotation':
            return TupleTypeAnnotation_1["default"](node, ctx);
        case 'TypeAlias':
            return TypeAlias_1["default"](node, ctx);
        case 'TypeAnnotation':
            return TypeAnnotation_1["default"](node, ctx);
        case 'TypeCastExpression':
            return TypeCastExpression_1["default"](node, ctx);
        case 'TypeParameterInstantiation':
            return TypeParameterInstantiation_1["default"](node, ctx);
        case 'TypeofTypeAnnotation':
            return TypeofTypeAnnotation_1["default"](node, ctx);
        case 'UnionTypeAnnotation':
            return UnionTypeAnnotation_1["default"](node, ctx);
        case 'VoidTypeAnnotation':
            return VoidTypeAnnotation_1["default"](node, ctx);
        default:
            fs_1.writeFileSync(__dirname + '/' + node.type + '.ts', "import * as bt from 'babel-types';\n" +
                "import Context from '../Context';\n" +
                "import print from './';\n\n" +
                'export default function print' +
                node.type +
                '(node: bt.' +
                node.type +
                ', ctx: Context): string {\n' +
                "  throw ctx.getError('Unsupported type " +
                node.type +
                "', node);\n" +
                '}\n');
            throw ctx.getError('Unsupported node type ' + node.type, node);
    }
}
exports["default"] = print;
