"use strict";
exports.__esModule = true;
var bt = require("babel-types");
var _1 = require("./");
function walkExportDefaultDeclaration(node, ctx) {
    if (ctx.defaultExport !== null) {
        throw ctx.getError('You can only have one default export per file', node);
    }
    if (bt.isDeclaration(node.declaration)) {
        var ids = _1["default"](node.declaration, ctx);
        if (ids.length !== 1) {
            throw ctx.getError('Expected exactly one declaration but got ' + ids.length, node);
        }
        ctx.setDefaultExport(ids[0]);
        return ids;
    }
    else {
        ctx.setDefaultExport(node.declaration);
        return [];
    }
}
exports["default"] = walkExportDefaultDeclaration;
