"use strict";
exports.__esModule = true;
var _1 = require("./");
function walkExportNamedDeclaration(node, ctx) {
    if (node.declaration) {
        var identifiers = _1["default"](node.declaration, ctx);
        return identifiers.map(function (id) {
            ctx.addNamedExport({
                type: 'ExportSpecifier',
                local: id,
                imported: undefined,
                exported: id,
                start: id.start,
                end: id.end,
                loc: id.loc
            });
            return id;
        });
    }
    node.specifiers.forEach(function (specifier) {
        ctx.addNamedExport(specifier);
    });
    return [];
}
exports["default"] = walkExportNamedDeclaration;
