"use strict";
exports.__esModule = true;
var bt = require("babel-types");
function walkVariableDeclaration(node, ctx) {
    return node.declarations.map(function (declaration) {
        if (!bt.isIdentifier(declaration.id)) {
            throw ctx.getError('tsgen only supports identifiers as variable declarations', declaration.id);
        }
        ctx.declare(declaration.id, {
            type: 'SingleVariableDeclaration',
            declaration: declaration,
            kind: node.kind,
            start: node.start,
            end: node.end,
            loc: node.loc
        });
        return declaration.id;
    });
}
exports["default"] = walkVariableDeclaration;
