"use strict";
exports.__esModule = true;
var fs_1 = require("fs");
var ClassDeclaration_1 = require("./ClassDeclaration");
var DeclareClass_1 = require("./DeclareClass");
var DeclareFunction_1 = require("./DeclareFunction");
var DeclareVariable_1 = require("./DeclareVariable");
var ExportDefaultDeclaration_1 = require("./ExportDefaultDeclaration");
var ExportNamedDeclaration_1 = require("./ExportNamedDeclaration");
var ExpressionStatement_1 = require("./ExpressionStatement");
var FunctionDeclaration_1 = require("./FunctionDeclaration");
var IfStatement_1 = require("./IfStatement");
var ImportDeclaration_1 = require("./ImportDeclaration");
var InterfaceDeclaration_1 = require("./InterfaceDeclaration");
var TryStatement_1 = require("./TryStatement");
var TypeAlias_1 = require("./TypeAlias");
var VariableDeclaration_1 = require("./VariableDeclaration");
function walk(node, ctx) {
    switch (node.type) {
        case 'ClassDeclaration':
            return ClassDeclaration_1["default"](node, ctx);
        case 'DeclareClass':
            return DeclareClass_1["default"](node, ctx);
        case 'DeclareFunction':
            return DeclareFunction_1["default"](node, ctx);
        case 'DeclareVariable':
            return DeclareVariable_1["default"](node, ctx);
        case 'ExportDefaultDeclaration':
            return ExportDefaultDeclaration_1["default"](node, ctx);
        case 'ExportNamedDeclaration':
            return ExportNamedDeclaration_1["default"](node, ctx);
        case 'ExpressionStatement':
            return ExpressionStatement_1["default"](node, ctx);
        case 'FunctionDeclaration':
            return FunctionDeclaration_1["default"](node, ctx);
        case 'IfStatement':
            return IfStatement_1["default"](node, ctx);
        case 'ImportDeclaration':
            return ImportDeclaration_1["default"](node, ctx);
        case 'InterfaceDeclaration':
            return InterfaceDeclaration_1["default"](node, ctx);
        case 'TryStatement':
            return TryStatement_1["default"](node, ctx);
        case 'TypeAlias':
            return TypeAlias_1["default"](node, ctx);
        case 'VariableDeclaration':
            return VariableDeclaration_1["default"](node, ctx);
        default:
            fs_1.writeFileSync(__dirname + '/' + node.type + '.ts', "import * as bt from 'babel-types';\n" +
                "import Context from '../Context';\n\n" +
                'export default function walk' +
                node.type +
                '(node: bt.' +
                node.type +
                ', ctx: Context): bt.Identifier[] {\n' +
                "  throw ctx.getError('Unsupported type " +
                node.type +
                "', node);\n" +
                '}\n');
            throw ctx.getError('Unsupported node type ' + node.type, node);
    }
}
exports["default"] = walk;
